#include <stdio.h>
#include <string.h>

struct label_list {
 
  int index;
  char lbl[25];
  struct label_list *next;
} *lbl_list;

int main(int argc, char *argv[])
{

  int i,j,len;
  FILE *fp1, *fp2;
  char line[80], function[25], temps[80], ans, line2[80];
  struct label_list ll, *llp;

  if (argc <=2) {
      printf("Usage: command source-filename temp-filename\n");
	exit(0);
  }

/*
  printf ("Temporary file will be removed after using.\nSource file will be over-written.\n Do you wish to continue ? ");
  ans = getchar();

  if (ans !='y')
     return 0;
*/

  fp1 = fopen (argv[1], "r");

  if (fp1 == NULL) {
      printf("Error opening file\n");
	exit(0);
  }

  fp2 = fopen (argv[2], "w");
  llp = &ll;
  llp->next= NULL;
  llp->index = -1;

  line2[0] = '\0'; 
  while (fgets(line, 80, fp1) != NULL) {
	int i;
	len = strlen(line);
	if (len >4) {
	for (i=0; i<= strlen(line)-4; i++) {

		/* build the label list, head is empty */
            strncpy(function, line+i, (7 < len-i ? 7 : len-i));
            function[7] = '\0';
	    if (strcmp (function, "def\tST_") == 0) {
		llp->next = 
			(struct label_list*)malloc(sizeof (struct label_list));
		llp = llp->next;

                sscanf (line+i+7, "%d", &(llp->index));
		while (line[i+7] != ';') i++;
                strncpy (llp->lbl, line+i+14, 8);
                for (j=0; j<8; j++) {
                    if (llp->lbl[j] == ';') {
                        llp->lbl[j] = '\0';
                        break;
     		    }
                }
                llp->next = NULL;
            }

	    strncpy(function, line+i, 3);
	    function[3] = '\0';

	    if (strcmp (function, "jal"))
	  	continue;

	    strncpy(function, line+i+4, 8);
	    function[8] = '\0';
	    if (strcmp(function, "ST_BEGIN") == 0 || 
		     strcmp(function, "st_begin")==0)
		sprintf (line, "\tbstr\n\0");

	    if (strcmp(function, "ST_LABEL") == 0) {
		llp->next = 
			(struct label_list*)malloc(sizeof (struct label_list));
		llp = llp->next;
		for (j=10; j<strlen(line2); j++)
			if (line2[j] == '#')
			    break;
		sscanf (line2+j+1, "%d", &(llp->index));
		sprintf (line, "$ST_%d:\n\0", llp->index);
		sprintf (llp->lbl, "$ST_%d\0", llp->index);
                llp->next = NULL;
	    }

	    strncpy(function, line+i+4, 4);
	    function[4] = '\0';
	    if (strcmp(function, "STL_") == 0) {
		llp->next = 
			(struct label_list*)malloc(sizeof (struct label_list));
		llp = llp->next;
		sscanf (line+i+8, "%d", &(llp->index));
		sprintf (line, "$ST_%d:\t#\n\0", llp->index);
		sprintf (llp->lbl, "$ST_%d\0", llp->index);
                llp->next = NULL;
	    }

	    strncpy(function, line+i+4, 14);
	    function[14] = '\0';

	    if (strcmp(function, "st_allocate_ts") == 0) {
		switch (line[i+19]) {
		    case 'b':
			strncpy (line+i, "altsb	$4\n\0", 10);
			break;
		    case 'h':
			strncpy (line+i, "altsh	$4\n\0", 10);
			break;
		    case 'w':
			strncpy (line+i, "altsw	$4\n\0", 10);
			break;
		    case 'd':
			strncpy (line+i, "altsd	$4\n\0", 10);
			break;
		}
	 	break;
	    }
   
	    strncpy(function, line+i+4, 11);
	    function[11] = '\0';

	    if (strcmp(function, "st_store_ts") == 0) {
		switch (line[i+16]) {
		    case 'b':
		 	if (line[i+17] == '_') /* FORTRAN */
				fprintf (fp2, "\tlb\t$5,0($5)\n");
			strncpy (line+i, "sttsb	$4, $5\n\0", 14);
			break;
		    case 'h':
		 	if (line[i+17] == '_') /* FORTRAN */
				fprintf (fp2, "\tlh\t$5,0($5)\n");
			strncpy (line+i, "sttsh	$4, $5\n\0", 14);
			break;
		    case 'w':
		    case 'f':
		 	if (line[i+17] == '_') /* FORTRAN */
				fprintf (fp2, "\tlw\t$5,0($5)\n");
			strncpy (line+i, "sttsw	$4, $5\n\0", 14);
			break;
		    case 'd':
		 	if (line[i+17] == '_') /* FORTRAN */ {
				fprintf (fp2, "\tlw\t$6,0($5)\n");
				fprintf (fp2, "\tlw\t$7,4($5)\n");
			}	
			strncpy (line+i, "sttsd	$4, $6\n\0", 14);
			break;
		}
	 	break;
	    }

	    strncpy(function, line+i+4, 13);
	    function[13] = '\0';

	    if (strcmp(function, "st_release_ts") == 0) {
		switch (line[i+18]) {
		    case 'b':
			strncpy (line+i, "rltsb	$4\n\0", 10);
			break;
		    case 'h':
			strncpy (line+i, "rltsh	$4\n\0", 10);
			break;
		    case 'w':
			strncpy (line+i, "rltsw	$4\n\0", 10);
			break;
		    case 'd':
			strncpy (line+i, "rltsd	$4\n\0", 10);
			break;
		}
	 	break;
	    }
   
	    strncpy(function, line+i+4, 7);
	    function[7] = '\0';

	    if (strcmp(function, "ST_FORK") == 0)  {
		strncpy (line+i, "hfrk	$4\n\0", 9);
		break;
	    }

	    if (strcmp(function, "ST_PFOR") == 0)  {
		strncpy (line+i, "pfrk	\n\0", 7);
		break;
	    }

	    if (strcmp(function, "ST_LFOR") == 0 || 
		    strcmp(function, "st_lfor") == 0)  {
		strncpy (line+i, "lfrk	\n\0", 7);
		break;
	    }

	    strncpy(function, line+i+4, 13);
	    function[13] = '\0';

	    if (strcmp(function, "ST_END_REGION") == 0 || 
		    strcmp(function, "st_end_region") == 0) {
		strncpy (line+i, "estr\n\0", 6);
		break;
	    }

	    strncpy(function, line+i+4, 15);
	    function[15] = '\0';

	    if (strcmp(function, "ST_ABORT_FUTURE") == 0 ||
		    strcmp (function, "st_abort_future") == 0 ) {
		strncpy (line+i, "abfutr\n\0", 8);
		break;
	    }
	    strncpy(function, line+i+4, 12);
	    function[12] = '\0';

	    if (strcmp(function, "ST_TSAG_DONE") == 0 ||
		    strcmp (function, "st_tsag_done") == 0 ) {
		strncpy (line+i, "tsagd\n\0", 7);
		break;
	    }
	    strncpy(function, line+i+4, 17);
	    function[17] = '\0';

	    if (strcmp(function, "ST_WAIT_TSAG_DONE") == 0 || 
		    strcmp (function, "st_wait_tsag_done") == 0 ) {
		strncpy (line+i, "wtsagd\n\0", 8);
		break;
	    }

	    strncpy(function, line+i+4, 15);
	    function[15] = '\0';

	    if (strcmp(function, "ST_ACQUIRE_LOCK") == 0) {
		strncpy (line+i, "glock\n\0", 8);
		break;
	    }
	    strncpy(function, line+i+4, 15);
	    function[15] = '\0';

	    if (strcmp(function, "ST_RELEASE_LOCK") == 0) {
		strncpy (line+i, "rlock\n\0", 8);
		break;
	    }
	}/* end for */
	}/* end if len > 4*/
	fprintf(fp2,"%s", line);
	strcpy (line2, line);

  }

  fclose (fp1);
  fclose (fp2);

  fp1 = fopen (argv[2], "r");
  fp2 = fopen (argv[1], "w");

  temps[0] = '\0';
  while (fgets(line, 80, fp1) != NULL) {
	int k;
	len = strlen (line);
	if (len > 5) {
	for (i=0; i< len - 5; i++) {

	    strncpy(function, line+i, 4);
	    function[4] = '\0';

	    if (strcmp (function, "hfrk") == 0) {
		for (j=0; j < strlen(temps); j++) 
		    if (temps[j] == '#')
			break;

		if (j < strlen(temps)) {
	        sscanf (temps+j+1, "%d", &k);
	
	        for (llp = ll.next; llp !=NULL; llp=llp->next) {
		    if (llp->index == k) 
		        break;
	        }
		/* over write the previous line , for hfrk addr format*
		sprintf (temps, "\thfrk\t%s\n\0", llp->lbl);
		line[0] = '\0';
		***********************/
		/* this line is for  hfrk reg format */
		sprintf (temps, "\tla\t$4,%s\n\0", llp->lbl);
		break;
 		}
	    }

	    strncpy(function, line+i, 5);
	    function[5] = '\0';
	    if (strcmp (function, "glock") == 0) {
		for (j=0; j < strlen(temps); j++) 
		    if (temps[j] == '#')
			break;
	        sscanf (temps+j+1, "%d", &k);
		sprintf (temps, "\tglock\t%d\n\0", k);
		line[0] = '\0';
	  	break;
	    }
	    if (strcmp (function, "rlock") == 0) {
		for (j=0; j < strlen(temps); j++) 
		    if (temps[j] == '#')
			break;
	        sscanf (temps+j+1, "%d", &k);
		sprintf (temps, "\trlock\t%d\n\0", k);
		line[0] = '\0';
	  	break;
	    }
	                    /* for alts? and rlts? */
            strncpy(function, line+i,4);
            function[4]='\0';
            if (strcmp (function, "alts") == 0 ||
                    strcmp (function, "rlts") == 0) {
                strncpy (function, temps+i, 4);
                function[4]='\0';
                if (strcmp (function, "move") == 0) {
                    for (j=i+4; j<strlen(temps); j++) {
                        if (temps[j] == ',')
                            break;
                    }
                    sscanf(temps+j+1, "%s", function);
                    sprintf(line+i+6,"%s\n\0",function);
                        /* remove previous line */
                    temps[0] ='\0';
                }
            }

                /* for stts? */
            strncpy(function, line+i,4);
            function[4]='\0';
            if (strcmp (function, "stts") == 0) {
                strncpy (function, temps+i, 4);
                function[4]='\0';
                if (strcmp (function, "move") == 0) {
                    for (j=i+5; j<strlen(temps)-1; j++) {
                        if (temps[j] == '$' && temps[j+1]=='4') {
                            sscanf(temps+j+3, "%s", function);
                            strncpy(line2,line,7);
                            sprintf(line2+7,"%s,%s\n\0",
                                function,line+i+11);
                            strcpy (line, line2);
                            /* remove previous line */
                            temps[0] ='\0';
                            break;
                        } else if (temps[j]=='$' && temps[j+1]=='5') {
                            sscanf(temps+j+3, "%s", function);
                            for (k=i; k<strlen(line); k++)
                                if (line[k] == ',')
                                    break;
                            sprintf(line+k+1,"%s\n\0",function);
                            temps[0]='\0';
                            break;
                        }
                    }
                }
            } /* end if stts */
	} /* end for */
 	} /* end if len > 5 */
	/* write the previous line */
	if (temps[0] != '\0')
	    fprintf(fp2, "%s", temps);
	strcpy(temps, line);
  }
  

  fprintf(fp2, "%s", line);
  fclose (fp1);
  fclose (fp2);

  fp1= fopen (argv[1], "r");
  fp2= fopen (argv[2], "w");

  temps[0] = '\0';
  while (fgets(line, 80, fp1) != NULL) {
        int k;
        len = strlen (line);
        if (len > 5) {
        for (i=0; i< len - 5; i++) {
                /* for stts? */
            strncpy(function, line+i,4);
            function[4]='\0';
            if (strcmp (function, "stts") == 0) {
                strncpy (function, temps+i, 4);
                function[4]='\0';
                if (strcmp (function, "move") == 0) {
                    for (j=i+5; j<strlen(temps)-1; j++) {
                        if (temps[j] == '$' && temps[j+1]=='4') {
                            sscanf(temps+j+3, "%s", function);
                            strncpy(line2, line, 7);
                            sprintf(line2+7,"%s,%s\n\0",
                                function,line+i+9);
                            strcpy (line, line2);
                            /* remove previous line */
                            temps[0] ='\0';
                            break;
                        } else if (temps[j]=='$' && temps[j+1]=='5') {
                            sscanf(temps+j+3, "%s", function);
                            for (k=i; k<strlen(line); k++)
                                if (line[k] == ',')
                                    break;
                            sprintf(line+k+1,"%s\n\0",function);
                            temps[0]='\0';
                            break;
                        }
                    } /* end for j */
                } /* end for move */
            } /* end for stts */
        } /* end for */
        } /* end if len > 5 */
        /* write the previous line */
        if (temps[0] != '\0')
            fprintf(fp2, "%s", temps);
        strcpy(temps, line);
  }

  fprintf(fp2, "%s", line);
  fclose (fp1);
  fclose (fp2);

  /* sprintf (line, "mv %s %s", argv[2], argv[1]); 
  system(line); */
}
